<?php

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add an install action
$thisplugin->add_action('plugin_install','javascript_tooltip_install');
$thisplugin->add_action('plugin_configure','javascript_tooltip_configure');

// Add an uninstall action
$thisplugin->add_action('plugin_uninstall','javascript_tooltip_uninstall');


// Add a filter for the gallery header
$thisplugin->add_filter('page_html','javascript_tooltip_filter');

$thisplugin->add_filter('gallery_footer','javascript_tooltip_footer');



// Install function
function javascript_tooltip_install() {
	
	global $thisplugin;
	
    // Install
	if(isset($_POST['ttAbove'])) {
	  isset($_POST['ttStatic']) ? $_POST['ttStatic'] = 'true' : $_POST['ttStatic'] = 'false';
	  isset($_POST['ttSticky']) ? $_POST['ttSticky'] = 'true' : $_POST['ttSticky'] = 'false';
	  $settings = "var ttAbove = ".$_POST['ttAbove']."; ";
	  $settings .= "var ttBgColor = '".$_POST['ttBgColor']."'; ";
	  $settings .= "var ttBgImg = '".$_POST['ttBgImg']."'; ";
	  $settings .= "var ttBorderColor = '".$_POST['ttBorderColor']."'; ";
	  $settings .= "var ttBorderWidth = ".$_POST['ttBorderWidth']."; ";
	  $settings .= "var ttDelay = ".$_POST['ttDelay']."; ";
	  $settings .= "var ttFontColor = '".$_POST['ttFontColor']."'; ";
	  $settings .= "var ttFontFace = '".$_POST['ttFontFace']."'; ";
	  $settings .= "var ttFontSize = '".$_POST['ttFontSize']."'; ";
	  $settings .= "var ttFontWeight = '".$_POST['ttFontWeight']."'; ";
	  $settings .= "var ttLeft = ".$_POST['ttLeft']."; ";
	  $settings .= "var ttOffsetX = ".$_POST['ttOffsetX']."; ";
	  $settings .= "var ttOffsetY = ".$_POST['ttOffsetY']."; ";
	  $settings .= "var ttOpacity = ".$_POST['ttOpacity']."; ";
	  $settings .= "var ttPadding = ".$_POST['ttPadding']."; ";
	  $settings .= "var ttShadowColor = '".$_POST['ttShadowColor']."'; ";
	  $settings .= "var ttShadowWidth = ".$_POST['ttShadowWidth']."; ";
	  $settings .= "var ttStatic = ".$_POST['ttStatic']."; ";
	  $settings .= "var ttSticky = ".$_POST['ttSticky']."; ";
	  $settings .= "var ttTemp = ".$_POST['ttTemp']."; ";
	  $settings .= "var ttTextAlign = '".$_POST['ttTextAlign']."'; ";
	  $settings .= "var ttTitleColor = '".$_POST['ttTitleColor']."'; ";
	  $settings .= "var ttWidth = ".$_POST['ttWidth']."; ";
	  
	  $settings = file_get_contents($thisplugin->fullpath."/wz_tooltip.part1").$settings.file_get_contents($thisplugin->fullpath."/wz_tooltip.part2");
	  file_put_contents("wz_tooltip.js",$settings);
	  return true;
	} else {
	  return 1;
	}
    
}

function javascript_tooltip_configure() {
  echo <<< EOT
  	<form action="{$_SERVER['REQUEST_URI']}" method="POST">
	Tooltip <input type="radio" value="false" checked="checked" name="ttAbove"/>below <input type="radio" value="true" name="ttAbove"/>above the mouse. <br/>
	Background color: <input type="text" name="ttBgColor" value="#e6ecff" /><br/>
	Background image: <input type="text" name="ttBgImg" value=""/><br/>
	Border color: <input type="text" name="ttBorderColor" value="#003399" /><br/>
	Border width: <input type="text" name="ttBorderWidth" value="1"/><br/>
	Delay till tool tip is shown (ms): <input type="text" name="ttDelay" value="500"/><br/>
	Font color: <input type="text" name="ttFontColor" value="#000066" /><br/>
	Font face: <input type="text" name="ttFontFace" value="arial,helvetica,sans-serif"/><br/>
	Font size: <input type="text" name="ttFontSize" value="11px"/><br/>
	Font weight (normal, bold): <input type="text" name="ttFontWeight" value="normal"/><br/>
	Tooltip <input type="radio" value="true" name="ttLeft"/>left <input type="radio" value="false" name="ttLeft" checked="checked"/>right of the mouse.<br/>
	Horizontal offset of left-top corner from mousepointer (px): <input type="text" name="ttOffsetX" value="12"/><br/>
	Vertical offset of left-top corner from mousepointer (px): <input type="text" name="ttOffsetY" value="15"/><br/>
	Opacity of the tooltip (integer percent): <input type="text" name="ttOpacity" value="100"/><br/>
	Spacing between border and content: <input type="text" name="ttPadding" value="3"/><br/>
	Shadow color: <input type="text" name="ttShadowColor" value="" /><br/>
	Shadow width: <input type="text" name="ttShadowWidth" value="0"/><br/>
	Move tooltip not with mouse: <input type="checkbox" name="ttStatic" value="false"/><br/>
	Do not hide tooltip on mouseout: <input type="checkbox" name="ttSticky" value="false"/><br/>
	Time span after which the tooltip disappears (zero means infinite): <input type="text" name="ttTemp" value="0"/><br/>
	Text align: <input type="radio" value="left" checked="checked" name="ttTextAlign"/>left <input type="radio" value="center" name="ttTextAlign"/>center <input type="radio" value="right" name="ttTextAlign"/>right<br/>
	Title color: <input type="text" value="#ffffff" name="ttTitleColor" /><br/>
	Breite: <input type="text" value="300" name="ttWidth"><br/>
	<input type="submit" value="OK" />
	<a href="http://en.selfhtml.org/helferlein/farben.htm" target="_blank">Colorpicker</a>
	</form>
EOT;
  
}

// Uninstall function
function javascript_tooltip_uninstall() {
  
  // Uninstall
  if(file_exists("wz_tooltip.js")) {
    unlink("wz_tooltip.js");
    
  }
  return true;
}

// Filter function
function javascript_tooltip_filter(&$html) {
  
  // Replace the title-attribute with the javascript function
  //preg_replace('/title="(.+)"/i/U','$0 onmouseover="return unescape($1)"',$html);
  preg_match_all('/title="([^"]*)"/i', $html,&$titles,PREG_SET_ORDER);
  foreach($titles as $title) {
	$html = str_ireplace($title[0],'onmouseover="return escape(\''.str_replace("\n","<br />",$title[1]).'\')"',$html);
  }
  return $html;
  
}

function javascript_tooltip_footer(&$html) {
  $html .= '<script language="javascript" src="wz_tooltip.js"></script>';
  return $html;
}

?>
